1000	%title "rdb_demo1_sqlcode_xxx.bas"
	%ident "version 100.1"
	!
	!========================================================================================================================
	! title  : rdb_demo1_sqlcode_xxx.bas
	! author : Neil Rieck	(http://www3.sympatico.ca/n.rieck)
	! purpose: to demo RDB71 concepts on ICSIS
	! notes  : also see file rdb_demo1_sqlcode_xxx_bas.sqlmod (which must be complied using SQLMOD71)
	! history:
	! ver who when   what
	! --- --- ------ --------------------------------------------------------------------------------------------------------
	! 100 NSR 040907 1. original code
	!========================================================================================================================
	! DCL Build Instructions:
	!	DCL command						result
	!	basic	rdb_demo1_sqlcode_xxx.bas			rdb_demo1_sqlcode_xxx.obj
	!	sql$mod	rdb_demo1_sqlcode_bas_xxx.sqlmod		rdb_demo1_sqlcode_bas_xxx.obj
	!	link	rdb_demo1_sqlcode_xxx.obj		, -
	!		rdb_demo1_sqlcode_bas_xxx.obj		, -
	!		SQL$USER/library				rdb_demo1_sqlcode_xxx.exe
	!
	! note: "SQL$USER" is a special logical created by executing "@sys$library:RDBVMS_SETVER.COM reset" or
	!	"@csmis$com:RDB_INIT_ENVIRONMENT.COM". This logical is currently defined as "SYS$COMMON:[SYSLIB]SQL$USER71.OLB"
	!	which could change with different versions of RDB (many versions can co-exist on the same system) so never
	!	hard code the library specification. Always use logical "SQL$USER".
	!========================================================================================================================
	option type=explicit
	!
	!	optional constant declarations (placed here to show that they exist)
	!
	%include "sys$library:SQL_LITERALS.BAS"					! end-of-stream for SQLCODE etc.
	%include "sys$library:COSIMSG.BAS"					!
	%include "sys$library:RDBMSGS.BAS"					!
	%include "sys$library:RDMSMSG.BAS"					!
	%include "sys$library:SQLSTATE.BAS"					! SQL State
	%include "sys$library:SQL_MSG.BAS"					! 
	%include "sys$library:SQL_SQLCA.BAS"					! Sql Communications Area
	!
	main:
	print "-i- this program uses SQLCODE"
	!
	!	older SQLMOD routines used SQLCODE but Rdb documentation (Oracle Rdb7 "Guide to SQL Programming" 10.2.1) states
	!	that new applications should use SQLSTATE (but you can also use both)
	!
    %let %new_method=0%								! OLD
    %if %new_method=0% %then
	!
	!	SQLCODE	values:		0	= succes
	!				100	= end of data
	!				< 0	= some kind of error
	!
	declare long sql_code							! from SQLCODE (a long integer)
    %else
	!                               ++-------- class code
	!                               ||+++----- sub-class code
	!       some SQLSTATE values:   00000 success
	!                               01000 warning
	!                               02000 no more data
	!                               2200F zero-length string
	!                               0H000 Invalid SQL state
	!                               S7000 bad version
	!
	map(sqlstate)   string sql_state	= 5                             ! from SQLSTATE (a 5 char string)
	map(sqlstate)   string sql_class        = 2     ,&
			string sql_subclass     = 3
    %end %if
	!
	declare	string	param1$, param2$					!
	!
	call open_cursor_customer_row_np(sql_code)				!
	print "-i- OPEN CURSOR sql_code: "; sql_code				!
	!
	!
	until sql_code <> 0							!
	    call fetch_customer_row_np(sql_code, param1$, param2$)		!
	    if sql_code = 0 then						! if no error, then process
		print "-i- FETCH CURSOR sql_code: "; sql_code			!
		print "-i- data: ";param1$;" ";param2$				!
	    else								!
		print "-e- sql_code: "; sql_code				!
	    end if								!
	next									!
	!
	!	closing the cursor reduces overhead
	!
	call close_cursor_customer_row_np(sql_code)
	print "-i- CLOSE CURSOR sql_code: "; sql_code
	!
	end
