1000	%title "RDB_DEMO3_load_assets_xxx.bas"
	%ident					"100.3"
	declare string constant k_version =	"100.3"
	!========================================================================================================================
	! title  : RDB_DEMO3_load_assets_xxx.bas
	! author : Neil Rieck		(http://www3.sympatico.ca/n.rieck)
	! purpose: This demo loads the contents of 2 RMS indexed files into 2 Oracle Rdb tables (so we can develop some skills)
	! notes  : this program calls SUB procedures created in RDB_DEMO3_load_assets_xxx_bas.SQLMOD
	! history:
	! ver who when   what
	! --- --- ------ --------------------------------------------------------------------------------------------------------
	! 100 NSR 040918 1. original program
	!     NSR 040919 2. added code to benchmark 'commit_evert_insert'
	!     NSR 040920 3. added code to support asset_history
	!========================================================================================================================
	! DCL Build Instructions:
	!	DCL command:						Result:
	!	--------------------------------------------		------------------------------------
	!	basic	rdb_demo3_load_assets_xxx.bas			rdb_demo3_load_assets_xxx.obj
	!	sql$mod	rdb_demo3_load_assets_bas_xxx.sqlmod		rdb_demo3_load_assets_bas_xxx.obj
	!	link	rdb_demo3_load_assets_xxx.obj		, -
	!		rdb_demo3_load_assets_bas_xxx.obj	, -
	!		SQL$USER/library				rdb_demo3_load_assets_xxx.exe
	!
	! note: "SQL$USER" is a special logical created by executing "@sys$library:RDBVMS_SETVER.COM reset" or
	!	"@csmis$com:RDB_INIT_ENVIRONMENT.COM". This logical is currently defined as "SYS$COMMON:[SYSLIB]SQL$USER71.OLB"
	!	which could change with different versions of RDB (many versions can co-exist on the same system) so never
	!	hard code the library specification. Always use logical "SQL$USER".
	!========================================================================================================================
	option type=explicit							! no tricks
	set no prompt								!
	declare string constant k_program = "RDB_DEMO3_load_assets"		!
	!
	%include "sys$library:SQL_LITERALS.BAS"					! end-of-stream etc. in SQLCODE
	%include "sys$library:COSIMSG.BAS"					!
	%include "sys$library:RDBMSGS.BAS"					!
	%include "sys$library:RDMSMSG.BAS"					!
	%include "sys$library:SQLSTATE.BAS"					! required with SQLSTATE
	%include "sys$library:SQL_MSG.BAS"					! 
	%include "sys$library:SQL_SQLCA.BAS"					! Sql Communications Area (SCA)
	!
	declare	long	i%			,&
			j%			,&
			rc%			,&
			be%			,&
			file31_open%		,&
			file33_open%		,&
			read_only%		,&
			counter%		,&
			commit_every_insert%	,&
		double	time0			,&
			time1			,&
		string	default_node$		,&
			default_dir$		,&
			junk$		
	!
	!				++-------- class code		see "sys$library:SQLSTATE.BAS" for more codes
	!				||+++----- sub-class code
	!	some SQLSTATE values:	00000 success
	!				01000 warning
	!				02000 no more data
	!				2200F zero-length string
	!				0H000 Invalid SQL state
	!				S7000 bad version
	!
	map(sqlstate)	string sql_state	= 5				! from SQLSTATE (a 5 char string)
	map(sqlstate)	string sql_class	= 2	,&
			string sql_subclass	= 3
	!
	%include "RDB_DEMO3_RMS_ASSETS.REC"					! asset record declarations
	!
	!	these SUB procedures represent routines defined in file 'RDB_DEMO3_load_assets_100_BAS.SQLMOD'
	!
	external sub SET_TRANSACTION(string)					! SQLSTATE
	external sub COMMIT_TRANSACTION(string)					! SQLSTATE
	external sub ROLLBACK_TRANSACTION(string)				! SQLSTATE
	external sub INSERT_ASSET(string,					! SQLSTATE					&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string)		! 26 data fields
	!
	!----------------------------------------------------------------------------------------------------
	!	main
	!----------------------------------------------------------------------------------------------------
	main:
	print k_program +"_"+ k_version
	print string$(len(k_program +"_"+ k_version), asc("="))
	print "ok to load RMS data in Rdb? (y/n, default=N) ";
	input junk$
	select left$( edit$(junk$,32+2) ,1)					! upcase, no white space
	    case "Y"
	    case else
		goto fini
	end select
	!
	print "test Rdb storage performance:"
	print "  1: commit every insert         (slow)"
	print "  2: commit only once at the end (fast)"
	print "choice? (1/2, default=2) ";
	input junk$
	select left$( edit$(junk$,32+2) ,1)					! upcase, no white space
	    case "1"
		commit_every_insert% = 1
		print "-i- will go SLOW"
	    case else
		commit_every_insert% = 0
		print "-i- will go FAST"
	end select
	!----------------------------------------------------------------------------------------------------
	!	load main ASSET records first
	!----------------------------------------------------------------------------------------------------
	print "-i- copying ASSET records"
	when error in
	    be%		= 0							! init
	    time0	= time(0)
	    !
	    default_dir$ = "csmis$ccc:"						! define the department directory
	    %include "RDB_DEMO3_RMS_ASSETS_OPEN31.OPN"				! open the asset file
	    counter% = 0
	    !
	    call SET_TRANSACTION( sql_state )					! prepare SQL
	    if sql_state <> "00000" then
		print "-e- SET_TRANSACTION: ";sql_state
		goto handle_basic_error1
	    end if
	    !
	    While 1
		get #31, regardless						! read w/o lock
		counter% = counter% + 1
		call INSERT_ASSET(sql_state,					! SQLSTATE		&
		    d131_status             ,					! start of 26 items	&
		    d131_system_name        ,&
		    d131_station            ,&
		    d131_device_name        ,&
		    d131_serial             ,&
		    d131_client             ,&
		    d131_contract           ,&
		    d131_clli               ,&
		    d131_installed_date     ,&
		    d131_warranty_exp       ,&
		    d131_flr                ,&
		    d131_address            ,&
		    d131_city               ,&
		    d131_name               ,&
		    d131_postal_code        ,&
		    d131_telephone          ,&
		    d131_prov               ,&
		    d131_severity           ,&
		    d131_loc                ,&
		    d131_est                ,&
		    d131_toe                ,&
		    d131_org                ,&
		    d131_netterm            ,&
		    d131_mac_address        ,&
		    d131_circuit            ,&
		    d131_notes              )
		if sql_state <> "00000" then
		    print "-e- INSERT_ASSET: ";sql_state
		    goto handle_basic_error1
		end if
		!
		if commit_every_insert% = 1 then				! if commit-every-insert is enabled
		    call COMMIT_TRANSACTION(sql_state)				!
		    if sql_state <> "00000" then
			print "-e- COMMIT: ";sql_state
			goto fini
		    end if
		end if
	    next
	use
	    be% = err								! remember this 'Basic Error'
	end when
	!
	handle_basic_error1:
	select be%								! test 'Basic Error'
	    case 0								! no error
	    case 11								! EOF (on RMS channel)
		print "-i- EOF on RMS data after "+ str$(counter%) +" records"
		if commit_every_insert% = 0 then				! if commit_every_insert is not enabled
		    print "-i- Now attempting an Rdb COMMIT"
		    call COMMIT_TRANSACTION(sql_state)
		    if sql_state <> "00000" then
			print "-e- COMMIT: ";sql_state
			goto fini
		    else
			print "-i- COMMIT was successful"
		    end if
		end if
	    case else
		print "-e-Unexpected Error: "+ str$(be%) +" Text: "+ ert$(be%)
		print "-i-Attempting Rdb ROLLBACK"
		call ROLLBACK_TRANSACTION(sql_state)
		if sql_state <> "00000" then
		    print "-e- ROLLBACK: ";sql_state
		    goto fini
		else
		    print "-i- ROLLBACK was successful"
		end if		
	end select
	time1	= time(0)
	print "elapsed time: "; time1 - time0 ;" seconds"
	!
	!----------------------------------------------------------------------------------------------------
	!	load ASSET_HISTORY records first
	!----------------------------------------------------------------------------------------------------
	print "-i- copying ASSET_HISTORY records"
	when error in
	    be%		= 0							! init
	    time0	= time(0)
	    !
	    default_dir$ = "csmis$ccc:"						! define the department directory
	    %include "RDB_DEMO3_RMS_ASSETS_OPEN33.OPN"				! open the asset-history file
	    counter% = 0
	    !
	    call SET_TRANSACTION( sql_state )					! prepare SQL
	    if sql_state <> "00000" then
		print "-e- SET_TRANSACTION: ";sql_state
		goto handle_basic_error2
	    end if
	    !
	    While 1
		get #33, regardless						! read w/o lock
		counter% = counter% + 1
		call INSERT_ASSET_HISTORY(sql_state,				! SQLSTATE		&
		    d133_system_name    ,&
		    d133_station        ,&
		    d133_date           ,&
		    d133_status         ,&
		    d133_initial        ,&
		    d133_text           )
		if sql_state <> "00000" then
		    print "-e- INSERT_ASSET_HISTORY: ";sql_state
		    goto handle_basic_error2
		end if
		!
		if commit_every_insert% = 1 then				! if commit-every-insert is enabled
		    call COMMIT_TRANSACTION(sql_state)				!
		    if sql_state <> "00000" then
			print "-e- COMMIT: ";sql_state
			goto fini
		    end if
		end if
	    next
	use
	    be% = err								! remember this 'Basic Error'
	end when
	!
	handle_basic_error2:
	select be%								! test 'Basic Error'
	    case 0								! no error
	    case 11								! EOF (on RMS channel)
		print "-i- EOF on RMS data after "+ str$(counter%) +" records"
		if commit_every_insert% = 0 then				! if commit_every_insert is not enabled
		    print "-i- Now attempting an Rdb COMMIT"
		    call COMMIT_TRANSACTION(sql_state)
		    if sql_state <> "00000" then
			print "-e- COMMIT: ";sql_state
			goto fini
		    else
			print "-i- COMMIT was successful"
		    end if
		end if
	    case else
		print "-e-Unexpected Error: "+ str$(be%) +" Text: "+ ert$(be%)
		print "-i-Attempting Rdb ROLLBACK"
		call ROLLBACK_TRANSACTION(sql_state)
		if sql_state <> "00000" then
		    print "-e- ROLLBACK: ";sql_state
		    goto fini
		else
		    print "-i- ROLLBACK was successful"
		end if		
	end select
	time1	= time(0)
	print "elapsed time: "; time1 - time0 ;" seconds"
	!
	!----------------------------------------------------------------------------------------------------
	!	adios
	!----------------------------------------------------------------------------------------------------
32000	fini:									!
	end									!
