1000	%title "RDB_DEMO3_ASSET_LOADER_COMPARE_xxx.bas"
	%ident					"100.1"
	declare string constant k_version =	"100.1"
	!========================================================================================================================
	! Title  : RDB_DEMO3_ASSET_LOADER_COMPARE_xxx.bas
	! Author : Neil Rieck
	! Created: 2004.09.20
	! Purpose: This program reads the contents of 2 RMS indexed files and transfers them, record by record, into 2 different
	!          RMS indexed files. The only purpose of this is to compare the run-times of an "RMS to RMS" transfer with that
	!	   of an "RMS to RDB" transfer (see RDB_DEMO3_LOAD_ASSET_xxx.bas)
	!========================================================================================================================
	option type=explicit							! no tricks
	set no prompt								!
	declare string constant k_program = "RDB_DEMO3_ASSET_LOADER_COMPARE"	!
	!
	declare	long	i%			,&
			j%			,&
			rc%			,&
			be%			,&
			file31_open%		,&
			read_only%		,&
			counter%		,&
			commit_every_insert%	,&
		double	time0			,&
			time1			,&
		string	default_node$		,&
			default_dir$		,&
			junk$		
	!
	%include "RDB_DEMO3_RMS_ASSETS.REC"					! asset record declarations
	!
	!----------------------------------------------------------------------------------------------------
	!	main
	!----------------------------------------------------------------------------------------------------
	main:									!
	print k_program +"_"+ k_version						!
	print string$(len(k_program +"_"+ k_version), asc("="))			!
	!
	when error in
	    be%		= 0							! init
	    time0	= time(0)
	    !
	    print "-i- opening ASSET for read"
	    default_dir$ = "csmis$ccc:"						! define the department directory
	    %include "RDB_DEMO3_RMS_ASSETS_OPEN31.OPN"				! open the asset file
	    counter% = 0
	    !
	    print "-i- opening new ASSET for write"
	    default_dir$ = "csmis$zzz:"						! define the department directory
	    open ( default_node$ + default_dir$ + k_fsa_ast_data$ ) for output as #99	&
		,access		modify							&
		,allow		modify							&
		,organization	indexed							&
		,contiguous								&
		,map		AstData131						&
		,primary   key	(d131_system_name,d131_station)				&
		,alternate key	d131_station	  duplicates changes			&
		,alternate key	d131_clli	  duplicates changes			&
		,alternate key	d131_serial       duplicates changes			&
		,alternate key	d131_netterm	  duplicates changes    		&
		,alternate key	d131_circuit	  duplicates changes
	    !
	    print "-i- copying"
	    While 1
		get #31, regardless						! read w/o lock
		put #99
		counter% = counter% + 1
	    next
	use
	    be% = err								! remember this 'Basic Error'
	end when
	!
	handle_basic_error:
	select be%								! test 'Basic Error'
	    case 0								! no error
	    case 11								! EOF (on RMS channel)
		print "-i- EOF on RMS data after "+ str$(counter%) +" records"
	    case else
		print "-e-Unexpected Error: "+ str$(be%) +" Text: "+ ert$(be%)
	end select
	!
	!----------------------------------------------------------------------------------------------------
	!	adios
	!----------------------------------------------------------------------------------------------------
32000	fini:									!
	time1	= time(0)							!
	print "elapsed time: "; time1 - time0 ;" seconds"			!
	end									!
