1000	%title "RDB_DEMO3_view_assets_xxx.bas"
	%ident					"102.3"
	declare string constant k_version =	"102.3"
	!========================================================================================================================
	! title  : RDB_DEMO3_view_assets_xxx.bas
	! author : Neil Rieck		(http://www3.sympatico.ca/n.rieck)
	! purpose: This demo views the contents of 2 Oracle Rdb tables (so we can develop some skills)
	! notes  : this program calls SUB procedures created in RDB_DEMO3_view_assets_xxx_bas.SQLMOD
	! history:
	! ver who when   what
	! --- --- ------ --------------------------------------------------------------------------------------------------------
	! 100 NSR 040923 1. original program
	! 101 NSR 040924 1. started adding support for FMS
	!     NSR 060620 2. replaced d131_rfa% with d131_rowid
	!     NSR 060621 3. added more code
	! 102 NSR 060624 1. started adding code to modify assets
	!     NSR 060625 2. more work
	!     NSR 060626 3. more work
	!========================================================================================================================
	! DCL Build Instructions:
	!	DCL command:						Result:
	!	--------------------------------------------		------------------------------------
	!	basic	rdb_demo3_view_assets_xxx.bas			rdb_demo3_view_assets_xxx.obj
	!	sql$mod	rdb_demo3_view_assets_bas_xxx.sqlmod		rdb_demo3_view_assets_bas_xxx.obj
	!	link	rdb_demo3_view_assets_xxx.obj		, -
	!		rdb_demo3_view_assets_bas_xxx.obj	, -
	!		SQL$USER/library				rdb_demo3_view_assets_xxx.exe
	!
	! note: "SQL$USER" is a special logical created by executing "@sys$library:RDBVMS_SETVER.COM reset" or
	!	"@csmis$com:RDB_INIT_ENVIRONMENT.COM". This logical is currently defined as "SYS$COMMON:[SYSLIB]SQL$USER71.OLB"
	!	which could change with different versions of RDB (many versions can co-exist on the same system) so never
	!	hard code the library specification. Always use logical "SQL$USER".
	!========================================================================================================================
	option type=explicit							! no tricks
	set no prompt								!
	!
	declare string constant k_program	= "RDB_DEMO3_view_assets"	!
	declare long constant k_max_history	= 100				!
        declare long constant k_scrl_top%	= 16				!
	!
    %if %variant>0% %then							! if FMS was desired at compile time...
	!
	!	<<< FMS Support >>>
	!
	%include "SYS$COMMON:[SYSHLP.EXAMPLES.FMS]FDVDEF.BAS"			!
	!
	declare long	constant k_fsize1% = 6000				! form-1 size
	declare string	constant k_fname1$ = "RDB_DEMO3_view_ASSETS_F1"		! form-1 name
	!
	declare long	constant k_fsize2% = 1000				! form-2 size
	declare string	constant k_fname2$ = "RDB_DEMO3_view_ASSETS_F2"		! form-2 name
	map(wksp_asset)								&
	    string	workspace_asset		= 12%				!
	map(wksp_assset_scr)							&
	    string	workspace_asset_hist	= 12%				!
	map(tca)								&
	    string	TCA			= 12%				! terminal control area
    %end %if
	!
	!	<<< RDB Support >>>
	!
	%include "sys$library:SQL_LITERALS.BAS"					! end-of-stream etc. in SQLCODE
	%include "sys$library:COSIMSG.BAS"					!
	%include "sys$library:RDBMSGS.BAS"					!
	%include "sys$library:RDMSMSG.BAS"					!
	%include "sys$library:SQLSTATE.BAS"					! required with SQLSTATE
	%include "sys$library:SQL_MSG.BAS"					! 
	%include "sys$library:SQL_SQLCA.BAS"					! Sql Communications Area (SCA)
	!
	!	this file contains map for our old RMS file definitions (which are also used by our Rdb)
	!	as well as our old FMS maps
	!
	%include "Rdb_demo3_RMS_ASSETS.REC"					! rms asset record + form declarations
	!
	declare	long		i%					,	&
				j%					,	&
				rc%					,	&
				be%					,	&
				file31_open%				,	&
				file33_open%				,	&
				read_only%				,	&
				counter%				,	&
				commit_every_insert%			,	&
				junk%					,	&
				secs%					,	&
				fms_verbose%				,	&
				scroll_last%				,	&
		double		time0					,	&
				time1					,	&
		string		default_node$				,	&
				default_dir$				,	&
				junk$					,	&
				cos_buffer$				,	&
		basic$quadword	d131_rowid				,	! ROWID = DBKEY					&
				d133_rowid					!
	!
	map(asset_history)							!						&
		string		scroll_lines$(k_max_history)=78%	,	!						&
		basic$quadword	d133_rowid(k_max_history)			!
	!
	!	this record is only used in program debugging [ because str$() doesn't support quadwords ]
	!
	record switcheroo							!
	    variant								!
		case								!
		    group one							!
			basic$quadword	quad0					!
		    end group one						!
		case								!
		    group two							!
			long		long0	,				!						&
					long1					!
		    end group two						!
	    end variant								!
	end record								!
	declare switcheroo QL							! QL (quad-long)
	!
	!				++-------- class code		see "sys$library:SQLSTATE.BAS" for more codes
	!				||+++----- sub-class code
	!	some SQLSTATE values:	00000 success
	!				01000 warning
	!				02000 no more data
	!				2200F zero-length string
	!				0H000 Invalid SQL state
	!				S7000 bad version
	!
	map(sqlstate)	string sql_state	= 5				! from SQLSTATE (a 5 char string)
	map(sqlstate)	string sql_class	= 2			,	!						&
			string sql_subclass	= 3				!
	!
	!
	!	<<< these SUB procedures represent routines defined in file 'RDB_DEMO3_view_assets_xxx_BAS.SQLMOD' >>>
	!
	external sub SET_TRANSACTION(string)					! SQLSTATE
	external sub COMMIT_TRANSACTION(string)					! SQLSTATE
	external sub ROLLBACK_TRANSACTION(string)				! SQLSTATE
	!
	!	asset-main
	!
	external sub OPEN_ASSET_MAIN_ROW(string)				! SQLSTATE
	external sub FETCH_ASSET_MAIN_ROW(string,				! SQLSTATE					&
	    basic$quadword,							! rowid						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string)		! 26 data fields
	external sub FETCH_ASSET_MAIN_ROW_BY_ROWID(string,			! SQLSTATE					&
	    basic$quadword,							! rowid						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string)		! 26 data fields
	external sub UPDATE_ASSET_MAIN(string,					! SQLSTATE					&
	    basic$quadword,							! rowid						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string,string,	!						&
	    string,string,string,string,string,string,string,string)		! 26 data fields
	external sub CLOSE_ASSET_MAIN_ROW(string)				! SQLSTATE
	!
	external sub OPEN_ASSET_MAIN_ROW_BY_ROWID(string,			! SQLSTATE					&
	    basic$quadword)							!
	!
	!	asset-history
	!
	external sub OPEN_ASSET_HISTORY_ROW(string,				! SQLSTATE					&
	    string,string)							!
	external sub FETCH_ASSET_HISTORY_ROW(string,				! SQLSTATE					&
	    basic$quadword,							! rowid						&
	    string,string,string,string,string,string)				! 6 data fields
	external sub CLOSE_ASSET_HISTORY_ROW(string)				! SQLSTATE
	!
	!----------------------------------------------------------------------------------------------------
	!	main
	!----------------------------------------------------------------------------------------------------
	main:									!
	print k_program +"_"+ k_version						!
	print string$(len(k_program +"_"+ k_version), asc("="))			!
	secs% = 1								!
	!
    %if %variant>0% %then							!					fms=yes
	!
	!	initialize FMS
	!
	call fdv$aterm( TCA by desc, 12%, 5%)					! attach terminal control area
	!
	call fdv$awksp( workspace_asset_hist	by desc, k_fsize2%)		! attach Workspace scroll
	call fdv$load( k_fname2$	)					! load form into WorkSpace
	call fdv$ndisp								!
	!
	call fdv$awksp( workspace_asset		by desc, k_fsize1%)		! attach WorkSpace asset
	call fdv$load( k_fname1$	)					! load form into WorkSpace
	call fdv$dispw								! display this work space
    %end %if									!
	!
	call OPEN_ASSET_MAIN_ROW(sql_state)					! open the r/o cursor
	!
    %if %variant>0 %then							!					fms=yes
	select sql_state							!
	    case "00000"							! if OK
		call fdv$putl("-i- OPEN_ASSET_MAIN_ROW: "+ sql_state , 23%)	!
		sleep secs%							!
		call fdv$putl("", 23%)						!
	    case else								! oops
		call fdv$getdl(junk$,junk%,23%, "-e- OPEN_ASSET_MAIN_ROW: "+ sql_state +", Hit <enter>...")
		call fdv$putl("",23%)						!
		goto handle_basic_error1					!
	end select
    %else									!					fms=no
	select sql_state							!
	    case "00000"							! if OK
		print "-i- OPEN_ASSET_MAIN_ROW: ";sql_state			!
		sleep secs%							!
	    case else								! oops
		print "-e- OPEN_ASSET_MAIN_ROW: ";sql_state			!
		goto handle_basic_error1					!
	end select
    %end %if									!
	!
	when error in								!
	    while 1								!
		call FETCH_ASSET_MAIN_ROW(					!				&
		    sql_state,							! SQLSTATE			&
		    d131_rowid		    ,					! ROWID (a.k.a. DBKEY)		&
		    d131_status, d131_system_name, d131_station,		&
		    d131_device_name, d131_serial, d131_client,			&
		    d131_contract, d131_clli, d131_installed_date,		&
		    d131_warranty_exp, d131_flr, d131_address,			&
		    d131_city, d131_name, d131_postal_code, d131_telephone,	&
		    d131_prov, d131_severity, d131_loc,				&
		    d131_est, d131_toe, d131_org,				&
		    d131_netterm, d131_mac_address, d131_circuit,		&
		    d131_notes)
    %if %variant>0 %then							!					fms=yes
		select sql_state
		    case "00000"						! if OK
			call fdv$putl("-i- FETCH_ASSET_MAIN_ROW: "+ sql_state, 23%)
			sleep secs%						!
			call fdv$putl("",23%)					!
		    case else							! oops
			call fdv$getdl(junk$,junk%,23%, "-e- FETCH_ASSET_MAIN_ROW: "+ sql_state +", Hit <enter>...")
			call fdv$putl("",23%)					!
			goto handle_basic_error1				!
		end select			
    %else									!					fms=no
		select sql_state						!
		    case "00000"						! if OK
			print "-i- FETCH_ASSET_MAIN_ROW: "+ sql_state		!
		    case else							! oops
			print "-e- FETCH_ASSET_MAIN_ROW: "+ sql_state		!
			goto handle_basic_error1				!
		end select							!
    %end %if									!
		!
    %if %variant>0 %then							!					fms=yes
		gosub copy_rdb_to_form						! copy RDB -> FMS form
		call fdv$putal(fsa_whole_form)					! bam
		QL::quad0 = d131_rowid						! prep to display rowid
		call fdv$putl("asset record: RowID = "+				!						&
		    str$(QL::long1) + str$(QL::long0) ,24% )			! put this on line #24
    %else									!					fms=no
		print "-i- data ===================="				!
		QL::quad0 = d131_rowid						! prep to display rowid
		print "ROWID      : "; str$(QL::long1) + str$(QL::long0)	!
		print "Status     : "; d131_status				!
		print "System_Name: "; d131_system_name				!
		print "Station    : "; d131_station				!
		print "Device_Name: "; d131_device_name				!
    %end %if									!
		if junk$ <> "C" then						! if not C/ontinuous mode
		    command_prompt:
    %if %variant>0 %then							!					fms=yes
		    call fdv$getdl(junk$,junk%,23%,"Choice? (N/ext_asset, E/xit, M/odify, C/ontinuous, V/iew_history) ")
    %else									!					fms=no
		    input "Choice? (N/ext_asset, E/xit, C/ontinuous, V/iew_history) "; junk$
    %end %if									!
		    junk$ = left$( edit$(junk$,32+2), 1)			!
		    select left$(junk$,1)					!
			case "N",""						! N/ext_asset
			case "M"						! M/odify
			    gosub modify_asset					!
			case "E"						! E/xit
			    be% = 0						! flag as 'no error'
			    goto handle_basic_error1				!
			case "C"						!
			    print "-i- C/ontinuous mode on"			!
			    sleep secs%						!
			    secs% = 0
			case "V"						! V/iew_history
			    gosub view_asset_history				!
			    goto command_prompt					!
			case "L"						! L/oad_history (a debug command)
			    gosub load_asset_history				!
			    goto command_prompt					!
			case else						!
			    print bel;						!
			    goto command_prompt					!
		    end select							!
		end if								!
	    next								! end if loop ---
	use									!
	    be% = err								! remember this 'Basic Error'
	end when								!
	!
	handle_basic_error1:							!
	select be%								! test 'Basic Error'
	    case 0								! no error
	    case else								!
    %if %variant>0 %then							!					fms=yes
		call fdv$getdl(junk$,junk%,23%,"-e-Unexpected Error: "+ str$(be%) +" Text: "+ ert$(be%) +", Hit <enter>...")
		call fdv$putl("",23%)						!
    %else									!					fms=no
		print "-e-Unexpected Error: "+ str$(be%) +" Text: "+ ert$(be%)	!
    %end %if									!
!		print "-i-Attempting Rdb ROLLBACK"				x
!		call ROLLBACK_TRANSACTION(sql_state)				x
!		if sql_state <> "00000" then					x if not OK
!		    print "-e- ROLLBACK: ";sql_state				x
!		    goto fini							x
!		else								x
!		    print "-i- ROLLBACK was successful"				x
!		end if								x
	end select								!
	!
	!	this stub probably isn't required before an exit, but I put it here anyway
	!
    %if %variant>0% %then							!					fms=yes
	call fdv$putl("-i- close cursor", 23%)					!
	sleep secs%								!
	call fdv$putl("",23%)							!
    %else									!					fms=no
	print "-i- close cursor"						!
    %end %if									!
	!
	call CLOSE_ASSET_MAIN_ROW(sql_state)					!
	if sql_state <> "00000" then						! if not OK
    %if %variant>0% %then							!					fms=yes
	    call fdv$getdl(junk$,junk%,23%, "-e- CLOSE_ASSET_MAIN_ROW: "+ sql_state +", Hit <enter>...")
	    call fdv$putl("",23%)						!					fms=no
    %else									!
	    print "-e- CLOSE_ASSET_MAIN_ROW: ";sql_state			!
    %end %if									!
	end if
	goto fini
	!
	!----------------------------------------------------------------------------------------------------
	!	<<< modify asset >>>
	!
	!	while we were sitting on this unlocked record (maybe we went for a coffee) it may have been
	!	modifed by someone else. So after locking it for update, we must do another fetch to make
	!	sure we have fresh data. 
	!----------------------------------------------------------------------------------------------------
	modify_asset:
    %if %variant=0 %then							!					fms=no
	print "-w- MODIFY is not supported in non-FMS mode"			!
	sleep 1									!
    %else									!					fms=yes
	call OPEN_ASSET_MAIN_ROW_BY_ROWID(sql_state, d131_rowid)		! grab the record (and place a lock on it)
	select sql_state							!
	    case "00000"							! OK
		call fdv$putl("-i- OPEN_ASSET_MAIN_ROW_BY_ROWID: "+ sql_state , 23%)
		sleep secs%							!
	    case else								! oops
		call fdv$getdl(junk$,junk%,23%, "-e- OPEN_ASSET_MAIN_ROW_BY_ROWID: "+ sql_state +". Hit <enter>...")
		goto modify_asset_exit						!
	end select								!
	call FETCH_ASSET_MAIN_ROW_BY_ROWID(					! apply lock etc.				&
	    sql_state,								! SQLSTATE					&
	    d131_rowid		    ,						! ROWID (a.k.a. DBKEY)				&
	    d131_status, d131_system_name, d131_station,			&
	    d131_device_name, d131_serial, d131_client,				&
	    d131_contract, d131_clli, d131_installed_date,			&
	    d131_warranty_exp, d131_flr, d131_address,				&
	    d131_city, d131_name, d131_postal_code, d131_telephone,		&
	    d131_prov, d131_severity, d131_loc,					&
	    d131_est, d131_toe, d131_org,					&
	    d131_netterm, d131_mac_address, d131_circuit,			&
	    d131_notes								)
	select sql_state							!
	    case "00000"							! if fetch was OK...
		call fdv$putl("-i- FETCH_ASSET_MAIN_ROW_BY_ROWID: "+ sql_state , 23%)
		    sleep secs%
	    case else								!
		call fdv$getdl(junk$,junk%,23%, "-e- FETCH_ASSET_MAIN_ROW_BY_ROWID: "+ sql_state +". Hit <enter>...")
		goto modify_asset_close						!
	end select								!
	cos_buffer$ = fsa_whole_form						! prep to do change-of-state test
	gosub copy_rdb_to_form							! copy rdb data into form (again)
	if cos_buffer$ <> fsa_whole_form then					! if data has changed...
	    call fdv$putal(fsa_whole_form)					! ... then update the form
	end if									!
	call fdv$put("Next: <TAB>, Prev: <Ctrl-BS>", "FS$PROGRAM_MODE")
	call fdv$getal(fsa_whole_form)						! now read the whole form
	if cos_buffer$ = fsa_whole_form then					! if they are the same
	    call fdv$getdl(junk$,junk%,23%, "-w- NOTHING CHANGED, Hit <enter>...")
	    call fdv$putl("",23%)						!
	else									!
	    call fdv$getdl(junk$,junk%,23%,"OK to save changes? (Y/N, default=Y) ")
	    select edit$(junk$,32+2)						!
		case "","Y"							!	    
		    call fdv$putl("Making Changes...", 23%)			!
		    sleep secs%							!
		case else							!
		    call fdv$putl("Discarded Changes...", 23%)			!
		    sleep secs%							!
		    goto modify_asset_close					!
	    end select 								!
	    gosub copy_form_to_rdb						!
	    call UPDATE_ASSET_MAIN(						!						&
		sql_state,							! SQLSTATE					&
		d131_rowid	,						! ROWID (a.k.a. DBKEY)				&
		d131_status, d131_system_name, d131_station,			&
		d131_device_name, d131_serial, d131_client,			&
		d131_contract, d131_clli, d131_installed_date,			&
		d131_warranty_exp, d131_flr, d131_address,			&
		d131_city, d131_name, d131_postal_code,				&
		d131_telephone,	d131_prov, d131_severity,			&
		d131_loc, d131_est, d131_toe,					&
		d131_org, d131_netterm, d131_mac_address,			&
		d131_circuit, d131_notes					)	    
	    select sql_state							!
		case "00000"							! if fetch was OK...
		    call fdv$putl("-i- UPDATE_ASSET_MAIN: "+ sql_state , 23%)
		    sleep secs%
		case else							!
		    call fdv$getdl(junk$,junk%,23%, "-e- UPDATE_ASSET_MAIN: "+ sql_state +". Hit <enter>...")
	    end select								!
	end if									!
	modify_asset_close:
	call CLOSE_ASSET_MAIN_ROW_BY_ROWID(sql_state)				!
    %end %if									!
	modify_asset_exit:
	return
	!
	!----------------------------------------------------------------------------------------------------
	!	view asset history
	!----------------------------------------------------------------------------------------------------
	view_asset_history:
	gosub load_asset_history
	if scroll_last% = 0 then
    %if %variant>0 %then
	    call fdv$putl("-e- No history available.", 23%)
    %else
	    print "-e- No history available."
    %end %if
	    goto display_history_exit
	end if
	!
    %if %variant>0 %then
	gosub View_History
	call fdv$ndisp								! show the help screen as not-displayed
	call fdv$clear (k_scrl_top%, 8%)
	call fdv$swksp ( WorkSpace_asset by desc )				! switch back to the asset screen
	call fdv$fix_screen							!
    %else
	for junk% = 1 to scroll_last%						!
	    print edit$( scroll_lines$(junk%) ,128)				! drop trailing spaces 
	next junk% 								!
    %end %if
	!
	display_history_exit:
	return
	!
	!----------------------------------------------------------------------------------------------------
	!	load assey history into an array
	!----------------------------------------------------------------------------------------------------
	load_asset_history:
	scroll_last% = 0
	mat scroll_lines$ = nul$
	!
	call open_asset_history_row(	 &
	    sql_state			,&			
	    d131_system_name		,&
	    d131_station		)
	if sql_state <> "00000" then						! if not OK
    %if %variant>0% %then							!					fms=yes
	    call fdv$getdl(junk$,junk%,23%,"OPEN_ASSET_HISTORY_ROW error: "+ sql_state +", hit <enter>...")
	    call fdv$putl("",23)						!
    %else									!					fms=no
	    print "-e- open_asset_history_row error: "+ sql_state		!
    %end %if									!
	    goto load_asset_history_exit					!
	end if									!
	!
	while scroll_last% < k_max_history					!
	    call fetch_asset_history_row(	 				&
		sql_state						,	&
		d133_rowid						,	&
		d133_system_name					,	&
		d133_station						,	&
		d133_date						,	&
		d133_status						,	&
		d133_initial						,	&
		d133_text							)
	    select sql_state							! check return code
		case "00000"							! OK so fall thru
		case "02000"							! EOF so exit
		    goto load_asset_history_exit				!
		case else							!
     %if %variant>0% %then							!					fms=yes
		    call fdv$getdl(junk$,junk%,23%,"FETCH_ASSET_HISTORY_ROW error: "+ sql_state +", hit <enter>...")
		    call fdv$putl("",23%)					!
    %else									!					fms=no
		    print "-e- open_asset_history_row error: "+ sql_state	!
    %end %if									!
		    goto load_asset_history_exit				!
	    end select
	    !
	    scroll_last% = scroll_last% + 1					! prep to insert into array
	    d133_rowid(scroll_last%)	= d133_rowid				! we might need this to update a record
	    scroll_lines$(scroll_last%)	= 					! insert...					&
		left$(d133_date,8) +"."+ right$(d133_date,9)	+" "+		! ccyymmdd.hhmmss				&
		d133_status					+" "+		!						&
		d133_initial					+" "+		!						&
		d133_text							!
	next									! end of loop ----
	!
	load_asset_history_exit:						!
    %if %variant>0% %then							!					fms=yes
	call fdv$putl( str$(scroll_last%) +" history records loaded", 23%)	!
    %else									!					fms=no
	print "-i- "+ str$(scroll_last%) +" history records loaded"		!
    %end %if									!
	call close_asset_history_row(sql_state)					!
	return									!

	!----------------------------------------------------------------------------------------------------
	!	copy RDB fields to form
	!----------------------------------------------------------------------------------------------------
	copy_rdb_to_form:
	fsa_whole_form		= ""						! init form map
	copy_rdb_to_form_no_init:
	fsa_status		= d131_status					! xfer RDB variables -> to FMS form
	fsa_system_name		= d131_system_name				!
	fsa_station		= d131_station					!
	fsa_device_name		= d131_device_name				!
	fsa_serial		= d131_serial					!
	fsa_client		= d131_client					!
	fsa_contract		= d131_contract					!
	fsa_clli		= d131_clli					!
	fsa_installed_date	= d131_installed_date				!
	fsa_warranty_exp	= d131_warranty_exp				!
	fsa_flr			= d131_flr					!
	fsa_address		= d131_address					!
	fsa_city		= d131_city					!
	fsa_name		= d131_name					!
	fsa_postal_code		= d131_postal_code				!
	fsa_telephone		= d131_telephone				!
	fsa_prov		= d131_prov					!
	fsa_severity		= d131_severity					!
	fsa_loc			= d131_loc					!
	fsa_est			= d131_est					!
	fsa_toe			= d131_toe					!
	fsa_org			= d131_org					!
	fsa_netterm		= d131_netterm					!
	fsa_mac_address		= d131_mac_address				!
	fsa_circuit		= d131_circuit					!
	fsa_notes		= d131_notes					!
	return

	!----------------------------------------------------------------------------------------------------
	!	copy form fields to rdb
	!----------------------------------------------------------------------------------------------------
	copy_form_to_rdb:
	d131_status		= fsa_status					! xfer FMS variables to RDB variables
	d131_system_name	= fsa_system_name				!
	d131_station		= fsa_station					!
	d131_device_name	= fsa_device_name				!
	d131_serial		= fsa_serial					!
	d131_client		= fsa_client					!
	d131_contract		= fsa_contract					!
	d131_clli		= fsa_clli 					!
	d131_installed_date	= fsa_installed_date				!
	d131_warranty_exp	= fsa_warranty_exp				!
	d131_flr		= fsa_flr					!
	d131_address		= fsa_address					!
	d131_city		= fsa_city					!
	d131_name		= fsa_name					!
	d131_postal_code	= fsa_postal_code 				!
	d131_telephone		= fsa_telephone 				!
	d131_prov		= fsa_prov					!
	d131_severity		= fsa_severity					!
	d131_loc		= fsa_loc 					!
	d131_est		= fsa_est					!
	d131_toe		= fsa_toe					!
	d131_org		= fsa_org 					!
	d131_netterm		= fsa_netterm					!
	d131_mac_address	= fsa_mac_address				!
	d131_circuit		= fsa_circuit					!
	d131_notes		= fsa_notes					!
	return

	!----------------------------------------------------------------------------------------------------
	!	view history (in an FMS scrolling window)
	!----------------------------------------------------------------------------------------------------
    %if %variant>0% %then							!					fms=yes
	declare long	current_line%, window_min%, window_max%, term%,		!&
			hit_scroll_limit%,					!&
		        pref_line%, num_scroll_line%, browse_mode%,		!&
			g_help_status%,						!&
		string	browse_mode$, num_scroll_line$						
	!
	!	caveat: the following scroll routines were pasted in from another program so some of the variable names
	!		may appear a little out-of-place
	!
	View_History:
	fms_verbose%	= 1
	g_help_status%	= 2							! indicate that history form is up
	browse_mode%	= 7							! indicate that we are browsing history
	pref_line%	= 1							! reset preferred line 
	call fdv$swksp ( WorkSpace_asset_hist by desc )				!
	call fdv$dispw ( k_scrl_top% - 1% )					! display the form
	call fdv$put("Asset-db History:", "F$SCROLL_TITLE")			! set up form title
	call fdv$put("UP/DOWN arrows to scroll, (default= X/it)", "F$SCROLL_HELP")
	!
	!	--- View Common ---
	!
	View_Common:
	!
	if scroll_lines$( scroll_last% ) = "" then
	    scroll_last% = scroll_last% - 1%
	end if
	!
	!	Get 'number-of-lines-in-scroll-area' from 'Form Named Data'
	!
	CALL FDV$RETDI( 1%, num_scroll_line$ )
	Num_scroll_line% = integer(num_scroll_line$)
	!
	! Put lines from help array into the scrolled area.  The window starts from item 1 up to
	! item MIN(num_scroll_line%, scroll_last%), that is, up to the size of the scrolled area or the size of the help,
	! whichever is less.  Assume there is at least one line.
	!
	pref_line% = scroll_last% if pref_line% = 0%
	!
	if scroll_last% <= Num_scroll_line%
	then									! no scroll window
	    current_line% = 1%							!
	    window_min% = 1%							!
	    window_max% = Num_scroll_line%		 			!
	else									! scroll window
	    window_min% = min( pref_line%,  scroll_last% - Num_scroll_line% + 1%)
	    window_max% = window_min% + Num_scroll_line% - 1%			!
	end if									!
	!
	for current_line% = window_min% to window_max%				! paint data into the window
	    call fdv$putsc('F$SCROLL_LINE', scroll_lines$( current_line%))	!
	    call fdv$pft( FDV$K_FT_SFW, 'F$SCROLL_LINE'	)			!						&
		if current_line% <> window_max%					!
	next current_line%							!
	!
	if scroll_last% <= Num_scroll_line% then				! correct window max
	    gosub Page_Backward							!
	    window_max% = scroll_last% 						!
	end if									!
	!
	! Get input from fake field of scrolled line and do what it says
	!	kpd . or RETURN/ENTER	=> return to menu
	!	UPARROW or TAB		=> scroll forward
	!	DOWNARROW or BACKSPACE	=> scroll backward
	!	all others	        => ignore
	! Note that there is no form function key UAR so this routine
	! handles all terminators itself (by ignoring illegal ones).
	!
	!
	term% = -1%								! init
	!
	while not ( term% = FDV$K_FT_NTR or term% = FDV$K_KP_PER )		!
	    if (term% = FDV$K_FT_SFW) or (term% = FDV$K_FT_SNX) then		!
		gosub	Scroll_Forward						!
	    end if								!
	    !
	    !	VT200 NEXT key
	    !
	    gosub page_forward if term% = FDV$K_FK_E6				!
	    !
	    if (term% = FDV$K_FT_SBK) or (term% = FDV$K_FT_SPR) then		!
		gosub	Scroll_Backward						!
	    end if								!
	    !
	    !	VT200 PREVious key
	    !
	    gosub page_backward if term% = FDV$K_FK_E5				!
	    !
	    !	wait for key press...
	    !
	    call fdv$get( junk$, term%, 'F$SCROLL_FAKE' )			!
	    !
	    browse_mode$ = edit$(junk$, 32%+4%+2%)				! pass info to subroutine
	    !
	    select browse_mode%							!
		case 7%								! browse system history
		     gosub Browse_history					!
	    end select								!
	    !
	next
	!
	if g_help_status% <> 0% then						! help form flag
	    call fdv$put("", "F$SCROLL_HELP")					!
	    call fdv$ndisp							! needed for UAR
	end if									!
	!
	view_common_exit:							!
	return									!
	!
	!======================================================================
	! SCROLL_FORWARD
	!
	! current_line% - the cursor is on this help line
	! window_min%   - is the first help line in the scroll area
	! window_max%   - is the last  help line in the scroll area
	!======================================================================
	!
	Page_Forward:
	junk% = Num_scroll_line%						!
	hit_scroll_limit% = 0%							!
	while ((junk%>0%) and (hit_scroll_limit% = 0%))				!
	    gosub Scroll_Forward						!
	    junk% = junk% - 1%							!
	next									!
	return									!
	!
	Scroll_Forward:
	if current_line% => scroll_last% then					!
	    hit_scroll_limit% = 1%						!
	    call fdv$putl( bel + 'On Last line' )				!
	    goto Scroll_Forward_exit						!
	end if									!
	!+
	! If cursor not at the last line of a window, just move down
	! If cursor is  at the last line of a window, 
	!	move window forward one line,
	!	write the new last line to the last line of the scrolled area
	! Move current line pointer forward
	!-
	if current_line% <> window_max% then					!
	    call fdv$pft( FDV$K_FT_SFW, 'F$SCROLL_LINE' )			!
	else									!
	    window_min% = window_min% + 1%					!
	    window_max% = window_max% + 1%					!
	    call fdv$pft( FDV$K_FT_SFW						&
			, 'F$SCROLL_LINE'					&
			, scroll_lines$(window_max%) )
	end if
	current_line% = current_line% + 1%					!
	call fdv$putl( bel + 'History Line: '+str$(current_line%) )	if fms_verbose% > 0
	!
	Scroll_Forward_exit:							!
	return									!
	!
	!======================================================================
	! Scroll_Backward
	!
	! current_line% - the cursor is on this help line
	! window_min%   - is the first help line in the scroll area
	! window_max%   - is the last  help line in the scroll area
	!======================================================================
	Page_Backward:
	junk% = Num_scroll_line%						!
	hit_scroll_limit% = 0%							!
	while ((junk%>0%) and (hit_scroll_limit% = 0%))				!
	    gosub Scroll_Backward						!
	    junk% = junk% - 1%							!
	next									!
	return									!
	!----------------------------------------------------------------------------------------------------
	Scroll_Backward:
	IF current_line% <= 1 THEN						!
	    hit_scroll_limit% = 1%						!
	    CALL FDV$PUTL( bel + 'On First line' )				!
	    goto Scroll_Backward_exit						!
	end if									!
	!+
	! If the cursor is not at first line of the window, just move up
	! If the cursor is     at first line of the window, 
	!	move window back one line,
	!	write the new first line to the first line of the scrolled area
	! Move current line pointer back
	!-
	if current_line% <> window_min%						! at 1st window line?
	then									! yes...
	    call fdv$pft( FDV$K_FT_SBK, 'F$SCROLL_LINE' )			! scroll back
	else									! no...
	    window_min% = window_min% - 1%					! move window back 1
	    window_max% = window_max% - 1%					!
	    call fdv$pft( FDV$K_FT_SBK						! scroll back	&
			,'F$SCROLL_LINE'					!		& 
			,scroll_lines$(window_min%) )				!
	end if
	current_line% = current_line% - 1%					! move current back 1
	call fdv$putl( bel + 'History Line: '+str$(current_line%) )	if fms_verbose% > 0
	!
	Scroll_Backward_exit:							!
	return									!
	!----------------------------------------------------------------------------------------------------
	Browse_history:
	if term% = FDV$K_FT_NTR then						! are we browsing
	    select browse_mode$							!
		case "X","","Q","E"						! X/it, E/xit, Q/uit
		case else							!
		    call fdv$putl(bel + "Invalid input")			!
		    term% = -1%							!
	    end select								!
	end if									!
	!
	return									!
    %end %if
	!
	!----------------------------------------------------------------------------------------------------
	!	adios
	!----------------------------------------------------------------------------------------------------
	fini:									!
	end									!
